<div class="container-fluid">
  <nb-card class="inline-form-card" id="page-layout">
    <nb-card-header>
    </nb-card-header>
    <nb-card-body>
      <div class="row" id="search-form" *ngIf="!isDetail && !isChart">
        <div class="col-lg-2">
          <div class="form-group row">
            <label>{{header}}</label>
            <div class="col-sm-10">
              <nb-radio-group>
                <nb-radio (click)="changeSR('S')" [checked]="!isMeta">Search</nb-radio>
                <nb-radio (click)="changeSR('R')" [checked]="isMeta">Retrieve</nb-radio>
              </nb-radio-group>
            </div>
          </div>
        </div>
        <div class="col-lg-6" *ngIf="isMeta">
          <form [formGroup]="searchByMetaForm" (ngSubmit)="loadMeta()">
            <div class="form-group row">
              <label for="inputOwner" class="col-sm-2 col-form-label">Owner</label>
              <div class="col-sm-10">
                <input type="text" formControlName="owner" class="form-control" nbInput fullWidth id="inputOwner"
                       placeholder="Owner">
              </div>
            </div>
            <div class="form-group row">
              <label for="inputAsset" class="col-sm-2 col-form-label">Asset</label>
              <div class="col-sm-10">
                <input type="text" formControlName="asset" class="form-control" id="inputAsset" nbInput fullWidth
                       placeholder="Asset">
              </div>
            </div>
            <div class="form-group row">
              <label for="inputModel" class="col-sm-2 col-form-label">Model</label>
              <div class="col-sm-10">
                <input type="text" formControlName="model" class="form-control" id="inputModel" nbInput fullWidth
                       placeholder="Model">
              </div>
            </div>
            <div class="form-group row">
              <label for="inputSubject" class="col-sm-2 col-form-label">Subject</label>
              <div class="col-sm-10">
                <input type="text" formControlName="subject" class="form-control" id="inputSubject" nbInput fullWidth
                       placeholder="Subject">
              </div>
            </div>
            <div class="form-group row">
              <label for="inputTimeRefFrom" class="col-sm-2 col-form-label">TimeRef:From</label>
              <div class="col-sm-10">
                <input id="inputTimeRefFrom" formControlName="timeRefFrom" [nbDatepicker]="datepickerFrom"
                       class="form-control" readonly
                       nbInput fullWidth placeholder="TimeRef:From" autocomplete="off">
                <nb-datepicker format="{{dateFormatStandard}}" (dateChange)="dateChangeFrom($event)"
                               [max]="minDateTo" #datepickerFrom></nb-datepicker>
              </div>
            </div>
            <div class="form-group row">
              <label for="inputTimeRefTo" class="col-sm-2 col-form-label">TimeRef:To</label>
              <div class="col-sm-10">
                <input id="inputTimeRefTo" formControlName="timeRefTo" [nbDatepicker]="datepickerTo"
                       class="form-control" readonly
                       nbInput fullWidth placeholder="TimeRef:To" autocomplete="off">
                <nb-datepicker format="{{dateFormatStandard}}"   (dateChange)="dateChangeTo($event)"
                               [min]="maxDateFrom" #datepickerTo></nb-datepicker>
              </div>
            </div>
            <div class="form-group row" style="margin-top: 30px;">
              <div class="btn-group">
                <button type="button" (click)="selectPeriod('1y')" nbTooltip="One year" nbButton status="basic"
                        size="small">1y
                </button>
                <button type="button" (click)="selectPeriod('1m')" nbTooltip="One month" nbButton status="basic"
                        size="small"
                        style="margin-left: 10px;">1m
                </button>
                <button type="button" (click)="selectPeriod('1w')" nbTooltip="One week" nbButton status="basic"
                        size="small"
                        style="margin-left: 10px;">1w
                </button>
                <button type="button" (click)="selectPeriod('1d')" nbTooltip="One day" nbButton status="basic"
                        size="small"
                        style="margin-left: 10px;">1d
                </button>
              </div>
            </div>
            <div class="btn-group" style="margin-top: 20px;">
              <button type="submit" nbButton status="primary">Load</button>
              <button type="button" (click)="resetMeta()" nbButton status="disabled" style="margin-left: 10px; ">Reset
              </button>
            </div>
          </form>
        </div>

        <div class="col-lg-3" *ngIf="isMeta">
          <div class="form-group row">
            <div class="col-sm-9">
              <input type="text" (input)="onChange($event)" class="form-control" id="inputSelQuery"
                     [formControl]="inputSelQuery" #queryInput
                     nbInput fullWidth placeholder="Saved Queries" [nbAutocomplete]="autoControl" autocomplete="off"
                     nbTooltip="Choose a saved query">
              <nb-autocomplete #autoControl (selectedChange)="onSelectionChange($event)">
                <nb-option *ngFor="let option of filteredOptions$ | async" [value]="option">
                  {{ option }}
                </nb-option>
              </nb-autocomplete>
            </div>
            <div class="col-sm-1" style="padding-left: 0px;">
              <div class="btn-group">
                <button type="button" nbButton status="primary" ghost nbTooltip="Save query" (click)="saveQuery()">
                  <nb-icon icon="save-outline" pack="eva" size="small"></nb-icon>
                </button>
                <button type="button" style="padding-left: 0px;" nbTooltip="Remove query" nbButton
                        [status]="!savedQueriesButtonGroupVisibility ? 'disabled': 'primary'"
                        [disabled]="!savedQueriesButtonGroupVisibility" (click)="deleteSavedQuery()"
                        ghost>
                  <nb-icon icon="trash-2-outline" pack="eva" size="small"></nb-icon>
                </button>
                <button type="button" style="padding-left: 0px;" nbTooltip="Rename query"
                        [disabled]="!savedQueriesButtonGroupVisibility" (click)="renameSavedQuery()"
                        nbButton [status]="!savedQueriesButtonGroupVisibility ? 'disabled': 'primary'"
                        ghost>
                  <nb-icon icon="text-outline" pack="eva" size="small"></nb-icon>
                </button>
              </div>
            </div>
          </div>
        </div>

        <div class="col-lg-10" *ngIf="!isMeta">
          <form [formGroup]="searchByIdForm" (ngSubmit)="loadId()">
            <div class="form-group row">
              <div class="col-sm-4">
                <input type="text" formControlName="id" class="form-control" id="inputId" nbInput fullWidth
                       placeholder="ID">
              </div>
            </div>
            <div class="btn-group">
              <button type="submit" nbButton status="primary">Load</button>
              <button type="button" (click)="resetId()" nbButton status="disabled" style="margin-left: 10px; ">Reset
              </button>
            </div>
          </form>
        </div>
      </div> <!-- Main Row -->

      <div class="row" *ngIf="isResult" id="search-results" style="margin-top: 50px;">
        <div class="col-sm-12">
          <nb-card>
            <nb-card-body>
              <div class="row" *ngIf="isMeta">
                <div class="col-lg-12">
                  <div style="margin-bottom: 10px;">
                    <button outline nbButton status="primary" [nbContextMenu]="dashboardItems">
                      <nb-icon icon="grid-outline" pack="eva"></nb-icon>
                      Dashboards
                    </button>
                    <button type="button" class="float-right" nbTooltip="Export to Excel" (click)="exportExcel()"
                            nbButton status="primary"
                            ghost>
                      <nb-icon icon="file-excel" pack="font-awesome" style="font-size: 1.1rem"></nb-icon>
                    </button>
                  </div>
                </div>
              </div>
              <div class="row">
                <div class="col-lg-12">
                  <ng2-smart-table id="qhd-table" [source]="source" [settings]="settings" style="cursor: pointer;"
                                   (userRowSelect)="onViewAction($event)"></ng2-smart-table>
                </div>
              </div>
            </nb-card-body>
          </nb-card>
        </div>
      </div>


      <div id="detail-result" *ngIf="isDetail && !isChart">
        <nb-card>
          <nb-card-header *ngIf="!isMeta">
            <button type="button" nbButton ghost status="primary" (click)="goToSearchById()">
              <nb-icon icon="arrow-back"></nb-icon>
            </button>
            {{header}} -> QH Browser [{{qhdSelected.id}}]
            <button class="float-right" type="button" ghost nbButton status="primary" size="medium"
                    nbTooltip="Export to Pdf" (click)="exportPdf(qhdSelected)">
              <nb-icon icon="file-pdf" style="font-size: 1.2rem" pack="font-awesome" size="large"></nb-icon>
            </button>
          </nb-card-header>
          <nb-card-header *ngIf="isMeta">
            <button type="button" ghost nbButton status="primary" (click)="goToSearchByMeta()">
              <nb-icon icon="arrow-back"></nb-icon>
            </button>
            {{header}} -> QH Browser [{{qhdSelected.id}}]
            <button class="float-right" type="button" ghost nbButton status="primary" size="medium"
                    nbTooltip="Export to Pdf" (click)="exportPdf(qhdSelected)">
              <nb-icon icon="file-pdf" style="font-size: 1.2rem" pack="font-awesome" size="large"></nb-icon>
            </button>
          </nb-card-header>
          <nb-card-body>
            <div id="header-container">
              <div class="form-group row">
                <label for="inputOwnerDetail" class="col-sm-2 col-form-label">Owner</label>
                <div class="col-sm-10">
                  <input type="text" class="form-control" id="inputOwnerDetail" nbInput fullWidth
                         readonly
                         value="{{qhdSelected.owner}}">
                </div>
              </div>
              <div class="form-group row">
                <label for="inputAssetDetail" class="col-sm-2 col-form-label">Asset</label>
                <div class="col-sm-10">
                  <input type="text" class="form-control" id="inputAssetDetail" nbInput fullWidth

                         readonly
                         value="{{qhdSelected.asset}}">
                </div>
              </div>
              <div class="form-group row">
                <label for="inputModelDetail" class="col-sm-2 col-form-label">Model</label>
                <div class="col-sm-10">
                  <input type="text" class="form-control" id="inputModelDetail" nbInput fullWidth

                         readonly
                         value="{{qhdSelected.model}}">
                </div>
              </div>
              <div class="form-group row">
                <label for="inputSubjectDetail" class="col-sm-2 col-form-label">Subject</label>
                <div class="col-sm-10">
                  <input type="text" class="form-control" id="inputSubjectDetail" nbInput fullWidth
                         readonly
                         value="{{qhdSelected.subject}}">
                </div>
              </div>
              <div class="form-group row">
                <label for="inputTimeRefDetail" class="col-sm-2 col-form-label">TimeRef</label>
                <div class="col-sm-10">
                  <input type="text" class="form-control" id="inputTimeRefDetail" nbInput fullWidth
                         readonly
                         value="{{qhdSelected.timeRefFormat}}">
                </div>
              </div>
            </div>
          </nb-card-body>
        </nb-card>
        <div id="body-container">
          <nb-card>
            <nb-card-body>
              <div class="form-group row">
                 <pre rows="10" style="width:100%">
                  <p id="qhd-body-formatted">
                      {{qhdSelected.bodyObj | prettyprint}}
                  </p>
                </pre>
              </div>
            </nb-card-body>
          </nb-card>
        </div>
      </div>
      <div id="chart-detail" *ngIf="!isDetail && !isResult && isChart">
        <nb-card>
          <nb-card-header>
            <button type="button" nbTooltip="Back" nbButton ghost status="primary" (click)="goToSearchByMeta()">
              <nb-icon icon="arrow-back"></nb-icon>
            </button>
            {{header}} -> InterQ standard dashboard
          </nb-card-header>
          <nb-card-body>
            <div *ngFor="let cdata of chartsData">
              <canvas baseChart
                      [data]="cdata"
                      [plugins]="chartPlugins"
                      [options]="options"
                      [type]="'bar'">
              </canvas>
            </div>
          </nb-card-body>
        </nb-card>
      </div>
    </nb-card-body>
  </nb-card>
</div>
